/******************************************************************************

    Test program for the lcd16.c module. Displays a floating point number
    on line one along with a fixed string. Displays a long integer (32-bits)
    and an integer (16-bits) on the second line. Increments the numbers by one
    forever.
  
  Ron Kreymborg
  
******************************************************************************/

#include <stdlib.h>
#include <avr/interrupt.h>
#include <avr/io.h>
#include <util/delay.h>
#include <compat/deprecated.h>
#include <string.h>
#include <math.h>
#include "lcd.h"

#define BYTE            unsigned char
#define WORD            unsigned int

int main(void);

char nibbles[]="0123456789abcdef";
void putint16hex(unsigned int i, unsigned char line, unsigned char column){
	unsigned char nibble;
	for (nibble=0;nibble<4;nibble++){
        SendCommand(0x80 + 0x40 * line + column - nibble);
	    SendData(nibbles[i&0xf]);
		i>>=4;
	}
}

int main(void)
{    
    float fnum;
    long lnum;
    int inum;
    
    InitLCD();
    fnum = 0.0;
    lnum = 0L;
    inum = 0;

/*
char *str="abcdefghijklmnopqrstuvwxyz0123456789"; //hello world!                          ";    
int pt;
int pos=0;
*/
    while (1)
    {
        //SendFloat(fnum, 1, 0);          // floating point number
        //fnum = fnum + 1.0;

        //SendString(str+pos, 1, 0);     // plain string
        //SendCommand(0xc0 + position);

/*
    for(pt=0;pt<16;pt++){
        SendCommand(0x80 + pt);
	    SendData(str[pos+pt]);
        SendCommand(0xC0 + pt);
	    SendData(str[pos+pt]);
}
     
   pos++;
	if(pos==16) pos=0;
_delay_ms(100);
_delay_ms(100);
_delay_ms(100);
_delay_ms(100);
*/

		putint16hex(lnum,0,7);
		putint16hex(lnum>>16,0,3);

        SendLong(lnum, 2, 0);           // long
        lnum+=27;
        
        //SendString("      ", 2, 10);    // ensure background cleared
        //SendInt(inum, 2, 10);           // int
        //inum++;
    }    
    
    return 0;
}


