
#include <avr/io.h>
#include <avr/interrupt.h>


//  Initialize USART0
void init_USART0(unsigned int baud){
	UBRR0 = baud;					   // Set Baudrate
	UCSR0C = (3<<UCSZ00);			   // Character Size 8 bit
	UCSR0B |= _BV(RXEN0) | _BV(TXEN0);  // Receiver and Transmitter Enable
	UCSR0A=0;
}

//  Set Receive Interrupt Enable
void setRXCIE_USART0(void){
	UCSR0B |= _BV(RXCIE0);
}

//  Receive 1 byte Data
unsigned char receive_1byte_USART0(void){
	loop_until_bit_is_set(UCSR0A, RXC0);
	return UDR0;
}

//  Transmit 1 byte Data
void transmit_1byte_USART0(unsigned char data){
	loop_until_bit_is_set(UCSR0A, UDRE0);
	UDR0 = data;
}

//  Transmit String Data
void transmit_str_USART0(char *str){
	while (*str != 0) {
		transmit_1byte_USART0(*str);
		str++;
	}
}

//  Transmit Four-Digit Integer
void transmit_4digit_USART0(unsigned int num){
	unsigned char temp;
	int digit = 10000;

	while (digit != 0) {
		temp = num / digit;
		transmit_1byte_USART0('0'+temp);
		num -= (digit*temp);
		digit /= 10;
	}
}
